////////////////////////////////////////////////////////////////////////////
//
//      Name:             WinMain.cpp
//      Erstellt:         21.05.2005
//      Letzte nderung:  14.11.2005
//
//      Beschreibung:     Programmeinsprungsfunktion
//
////////////////////////////////////////////////////////////////////////////

#include "main.h"
#include <windows.h>

/*!!!!!!!!!!!!!!!!!*/ 
#include "calc.h"
#include <fstream>
#include <stdlib.h>

// ---------------------------------------------------------------------- \\

int WINAPI WinMain ( HINSTANCE hInst, HINSTANCE hPrevInst, 
                     LPSTR szArgument, int nFunsterStil )
{
  // Instanz global zugnglich machen
  globals().hInst = hInst;
  
  // Hauptdialog anzeigen
  return DialogBox ( hInst, "MainDlg", NULL, MainDlgProc );
  
  
/*!!!!!!!!!!!!!!!!!
CALC_INPUT input;
CALC_RESULT result;

ZeroMemory ( &input, sizeof ( CALC_INPUT ) ); 
ZeroMemory ( &result, sizeof ( CALC_RESULT ) ); 
  
input.iType = TYPE_DWZ;
input.iRo = 1150;
input.iSet1 = 0;
input.iSet2 = 44;

input.iRatings [0] = 1920;
input.iScore [0] = 0;
input.iRatings [1] = 1920;
input.iScore [1] = 0;
input.iRatings [2] = 1714;
input.iScore [2] = 0;
input.iRatings [3] = 1055;
input.iScore [3] = 0;
input.iRatings [4] = 1850;
input.iScore [4] = 0;
input.iRatings [5] = 1650;
input.iScore [5] = 0;
input.iRatings [6] = 1850;
input.iScore [6] = 1;

ofstream out ( "log.txt" );
out << CalcRating ( input, &result ) << endl;
out << result.iRo << endl;
out << result.iN << endl;
out << result.iRc << endl;
out << result.dW << endl;
out << result.dWe << endl;
out << result.iRh << endl;
out << result.iRn << endl;

WinExec ( "notepad log.txt", SW_SHOW );  
  
!!!!!!!!!!!!!!!!!*/ 
  
}

// ---------------------------------------------------------------------- \\
