////////////////////////////////////////////////////////////////////////////
//
//      Name:             main.h
//      Erstellt:         21.05.2005
//      Letzte nderung:  15.12.2005
//
//      Beschreibung:     Grundstzliche Definitionen
//
////////////////////////////////////////////////////////////////////////////

#ifndef _MAIN_H
#define _MAIN_H

// ---------------------------------------------------------------------- \\

#include <windows.h>
#include "..\\res\\res.h"

// Grundstzliches
#define EDIT_COUNT                11
#define MY_MAX_PATH               MAX_PATH*3
#define SIGNATUR                  42
#define SZ_ALERT                  "%s\n\nFehlercode: %i-%i-%s-%i\nBitte lesen Sie auch die Hilfe."
#define SZ_DOCNAME                "DWZ- und ELO-Rechner Ausdruck"
#define SZ_DSBDB                  "http://deutscher-schachbund.de/dwz/db/spieler.html?name=%s,%s"
#define SZ_ELO24_MSG              "Um die neue Wertungszahl genau zu berechnen\nwird noch eine Zusatzinfo bentigt:\n\nHatten Sie jemals eine ELO-Zahl ber oder gleich 2400?" 
#define SZ_EXPORT_TITLE           "Exportieren nach..."
#define SZ_EXPORT1                "Alle Dateien\0*.*\0\0"
#define SZ_EXPORT2                "*.*"
#define SZ_HELP                   "----- HILFE -----\r\n\r\nInhalt\r\nA. Berechnung von Wertungszahlen\r\n   A1. Berechnung einer neuen DWZ\r\n   A2. Berechnung einer neuen ELO\r\n   A3. Berechnung der ersten DWZ-Zahl\r\n   A4. Berechnung der ersten ELO-Zahl\r\n\r\nB. Sonderfunktionen\r\n   B1. Spieler Wertungszahl online suchen\r\n   B2. Programm reparieren\r\n   B3. Import aus alten Formaten\r\n\r\nC. Fehlerbehandlung\r\n   C1. Support bei Fehlern\r\n   C2. Fehlercodes\r\n\r\n\r\n---- A. BERECHNUNG VON WERTUNGSZAHLEN -----\r\n\r\nA1. Berechnung einer neuen DWZ\r\n\r\nWhlen Sie aus der Liste Typ den Eintrag \"DWZ-Vernderung\". DWZ-Zahlen werden pro Turnier berechnet, geben Sie deshalb bitte nur Ergebnisse aus einem Turnier ein, um das Berechnungsergebnis nicht zu verflschen. Geben Sie im Feld Alter ihr aktuelles Alter an, wobei fr die Berechnung nur relevant ist, ob der Auszuwertende unter 21, 21-25 oder ber 25 Jahre alt ist. Im Feld Bisherige Anzahl Berechnungen geben Sie bitte ihren Index ein, der in der DSB-Datenbank meist hinter der Wertungszahl mit einem Bindestrich getrennt steht. Sollten Sie diesen nicht kennen, geben Sie bitte 6 ein. Ein Wert grer 6 ist nur in wenigen Fllen Ausschlag gebend.\r\nGeben Sie anschlieend im Feld Partien alle Wertungszahlen ihrer Gegner und das Ergebnis der Partie aus ihrer Sicht (0, 0,5 oder 1) ein. Hatte ein Gegner keine DWZ so lassen Sie das Feld frei oder geben Sie 0 ein. Inwiefern DWZ lose Gegner die Auswertung beeinflussen lesen Sie in den Hinweisen bei den Berechnungsergebnissen. Ist ihnen die DWZ ihres Gegners nicht bekannt, knnen Sie die Funktion \"Spieler suchen...\" benutzen, siehe Abschnitt B1.\r\n\r\nA2. Berechnung einer neuen ELO\r\n\r\nWhlen Sie aus der Liste Typ den Eintrag \"ELO-Vernderung\". ELO-Zahlen werden pro Turnier berechnet, geben Sie deshalb bitte nur Ergebnisse aus einem Turnier ein, um das Berechnungsergebnis nicht zu verflschen. Im Feld Bisherige gewertete Partien geben Sie bitte die Zahl der bisherigen Partien gegen ELO-Gegner ein. Entscheidend ist hierbei nur, ob der Wert grer oder kleiner 30 ist. Ein Wert ber 30 sorgt in der Regel fr eine geringere ELO-Vernderung.\r\nGeben Sie anschlieend im Feld Partien alle Wertungszahlen ihrer Gegner und das Ergebnis der Partie aus ihrer Sicht (0, 0,5 oder 1) ein. Hatte ein Gegner keine ELO so lassen Sie das Feld frei oder geben Sie 0 ein, denn diese Gegner beeinflussen die Berechnung nicht. Ist ihnen die ELO ihres Gegners nicht bekannt, knnen Sie bei deutschen Spielern die Funktion \"Spieler suchen...\" benutzen, siehe Abschnitt B1.\r\n\r\nA3. Berechnung der ersten DWZ\r\n\r\nWhlen Sie aus der Liste Typ den Eintrag \"Erste DWZ\". Geben Sie anschlieend im Feld Partien alle Wertungszahlen ihrer Gegner und das Ergebnis der Partie aus ihrer Sicht (0, 0,5 oder 1) ein. Hatte ein Gegner keine DWZ, so lassen Sie das Feld frei oder geben Sie 0 ein. Inwiefern DWZ lose Gegner die Auswertung beeinflussen lesen Sie in den Hinweisen bei den Berechnungsergebnissen. Ist ihnen die DWZ ihres Gegners nicht bekannt, knnen Sie die Funktion \"Spieler suchen...\" benutzen, siehe Abschnitt B1.\r\nHinweise zum Erhalten einer ersten DWZ lesen Sie bei den Berechnungsergebnissen.\r\n\r\nA4. Berechnung der ersten ELO\r\n\r\nWhlen Sie aus der Liste Typ den Eintrag \"Erste ELO\". Geben Sie anschlieend im Feld Partien alle Wertungszahlen ihrer Gegner und das Ergebnis der Partie aus ihrer Sicht (0, 0,5 oder 1) ein. Hatte ein Gegner keine ELO, so lassen Sie das Feld frei oder geben Sie 0 ein, denn diese Gegner beeinflussen die Berechnung nicht. Ist ihnen die ELO ihres Gegners nicht bekannt, knnen Sie fr deutsche Spieler die Funktion \"Spieler suchen...\" benutzen, siehe Abschnitt B1.\r\nHinweise zum Erhalten einer ersten ELO lesen Sie bei den Berechnungsergebnissen.\r\n\r\n\r\n---- B. SONDERFUNKTIONEN -----\r\n\r\nB1. Spieler Wertungszahl online suchen\r\n\r\nUm die DWZ oder ELO Zahl eines deutschen Spielers zu suchen, whlen Sie im Men \"Bearbeiten\" den Eintrag \"Spieler suchen...\". Im erscheinenden Dialog geben Sie wie dort beschrieben in die Felder den Namen des zu suchenden Spielers ein und klicken auf \"Suchen\". Wenig spter sollte sich eine Internetseite der DWZ-Datenbank der Deutschen Schachbundes ffnen. Bei Fehlern kontaktieren Sie bitte den Autor (siehe Punkt C1).\r\n\r\nB2. Programm reparieren\r\n\r\nSollte es beim Programmablauf zu ungewhnlichen Ausgaben oder Schweren Ausnahmefehlern kommen, whlen Sie im Men \"?\" den Eintrag \"Selbstreparieren\". Nach einer Informationsmeldung sollte sich das Programm beenden. Treten die Fehler nach dem ffnen des Programms erneut auf, kontaktieren sie bitte den Autor (siehe Punkt C1).\r\n\r\nB3. Import aus alten Formaten\r\n\r\nAlte Dateiformate aus lteren Versionen (1.x) knnen wie die aktuellen einfach ber das Men \"Datei\" und den Eintrag \"ffnen...\" geffnet werden.\r\n\r\n\r\n----- C. FEHLERBEHANDLUNG -----\r\n\r\nC1. Support bei Fehlern\r\n\r\nSollten Sie Probleme beim Interpretieren von Fehlermeldungen haben oder sollten beim Programmablauf unerklrliche Ausgaben auftreten und die Selbstreparatur (Punkt B2) nicht helfen, kontaktieren Sie bitte den Programmautor (Kontaktdaten siehe Programminfo im Men \"?\") unter Angabe der ausgefhrten Schritte bzw. bei Fehlermeldungen des Fehlercodes.\r\n\r\nC2. Fehlercodes\r\n\r\nBei Fehlermeldungen wird ein Fehlercode ausgegeben, der Auskunft ber Art des Fehlers und ber die Quelle im Quelltext gibt, die den Fehler verursacht. Geben Sie diesen Fehlercode bitte bei angefordertem Fehlersupport (siehe C1) an.\r\n\r\n"
#define SZ_HOMEPAGE               "http://mellij.de"
#define SZ_INFO                   "----- PROGRAMMINFO -----\r\n\r\nAutor:\t\tMarcel Jnemann\r\nEmail:\t\twebmaster@sjbh.de\r\nHomepage:\thttp://mellij.de\r\nVersion:\t\t2.0\r\n\r\nDie berechneten Zahlen knnen von den offizielen Zahlen des DSB oder der FIDE abweichen, siehe Hilfe und Hinweise bei den Berechnungsergebnissen.\r\n\r\nFragen, Verbesserungsvorschlge und Kritik knnen dem Autor per Email zugestellt werden und werden gerne entgegengenommen und beantwortet.\r\n\r\nDieses Programm ist Freeware und darf zu privaten Zwecken nach Belieben kopiert und weitergegeben werden, solange das Programm nicht verndert wurde. Zur kommerzielen Nutzung des Programmes (auch zur Verffentlichung auf Heft-CDs und -DVDs) ist eine ausdrckliche Erlaubnis des Autors erforderlich, schriftlich oder per Email.\r\n\r\nDer Quelltext kann auf der Homepage des Autors heruntergeladen werden. Er darf kopiert, verndert und weitergegeben werden, vorausgesetzt das erzeugte Programm ist ebenfalls ein OpenSource Projekt.\r\n\r\nDas Programm wird Ihnen \"so wie es ist\" zur Verfgung gestellt, ohne Gewhrleistung irgendeiner Art, weder ausdrcklich noch implizit. Die Benutzung und Ausfhrung des Programms erfolgt auf eigenes Risiko. Der Urheber haftet nicht fr Schden sachlicher, wirtschaftlicher oder ideeller Art, die durch die Verwendung des Programms entstanden sein knnten. Der Autor kann fr durch dieses Programm entstandene Schden weder eine juristische Verantwortung noch irgendeine Haftung bernehmen.\r\n\r\nDAS GESAMTE RISIKO, DAS SICH AUS DEM VERWENDEN DES PROGRAMMES ERGIBT, VERBLEIBT BEI IHNEN.\r\n"
#define SZ_INI_FILE               "DwzEloRechner.dat"
#define SZ_OPENSAVE1              "DWZ/ELO Auswertungen (*.dwz)\0*.dwz\0Alle Dateien\0*.*\0\0"
#define SZ_OPENSAVE2              "*.dwz"
#define SZ_OPEN_TITLE             "Datei ffnen..."
#define SZ_QUERY_MSG              "Die Datei wurde gendert.\nMchten Sie die nderungen speichern?"
#define SZ_QUERY_TITLE            "DWZ- und ELO-Rechner"
#define SZ_SAVE_TITLE             "Datei speichern unter..."
#define SZ_SHELL_OPEN             "open"
#define SZ_SHELL_PRINT            "print"
#define SZ_TEMP_FILE              "\\DWZ- und ELO-Rechner von www.mellij.de.txt"
#define WMU_CLEAR                 (WM_USER+1)
#define WMU_SET                   (WM_USER+3)
#define WMU_STORE                 (WM_USER+4)
#define WMU_QUERY                 (WM_USER+5)         
  
// Makros
#define Alert( h, i )              AlertEx ( h, i, __FILE__, __LINE__ )

// Strukturen
struct SETTINGS
{
  char        szExportFile [MY_MAX_PATH];
  char        szFilename [MY_MAX_PATH];
  int         iLastAge;
  int         iLastCount;
  int         iLastRating;
  int         iLastType;
};

struct GLOBALS
{
  HINSTANCE   hInst;
  HWND        hMainDlg;
  SETTINGS    settings;
};


// Grundstzliche Funktionen
bool AlertEx ( HWND, int, char *, int );
BOOL ExploreForFile ( bool, char *, char *, int, HWND = NULL, char * = SZ_OPENSAVE1, char * = SZ_OPENSAVE2 );
GLOBALS &globals ();

// INI-Funktionen
bool GetINIFilename ( char *, int );
bool ReadINI ( SETTINGS * );
bool WriteINI ( SETTINGS * );

// Prototypen
BOOL CALLBACK FindDlgProc ( HWND, UINT, WPARAM, LPARAM );
BOOL CALLBACK MainDlgProc ( HWND, UINT, WPARAM, LPARAM );
BOOL CALLBACK TextDlgProc ( HWND, UINT, WPARAM, LPARAM );

// ---------------------------------------------------------------------- \\

#endif

